(*

  AMPRNG pseudo-random generator test utility

  Generates random file,
  such file you can test by ENT or DIEHARD batterry.

  (c) 2010 Alexander Myasnikov

  e-mail: alexanderwdark@ya.ru

*)

program amprng;
{$APPTYPE CONSOLE}

uses
  SysUtils,
  amprng10;

var
  F: integer;
  buffer: array [0 .. 511] of byte;
  key, iv: array [0 .. 63] of byte;
  i: integer;
  AM: TAMPRNG;

begin

  if (paramcount < 1) then
  begin
    writeln(Format('usage: %s <output filename>', [ParamStr(0)]));
    halt(1);
  end;

  F := FileCreate(ParamStr(1));

  if (F = 0) then
  begin
    writeln(Format('failed to open ''%s'' for writing.', [ParamStr(1)]));
    halt(1);
  end;

  for i := 0 to 63 do
  begin
    key[i] := i and 5;
    iv[i] := i and 2;
  end;

  AM := TAMPRNG.Create(key, 64, True, 768);
  AM.SetIV(iv, 64);

  for i := 0 to (1024 * 1024) - 1 do
  begin

    AM.GenerateRandom(buffer, 128);
    FileWrite(F, buffer, 128);

  end;

  fileclose(F);
  AM.Free;

end.
